Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/wxml/m_wxml_buffer.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/wxml/m_wxml_buffer.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/wxml/m_wxml_buffer.f90	(revision 2528)
@@ -0,0 +1,176 @@
+module m_wxml_buffer
+
+!
+! At this point we use a fixed-size buffer. 
+! Note however that buffer overflows will only be
+! triggered by overly long *unbroken* pcdata values, or
+! by overly long attribute values. Hopefully
+! element or attribute names are "short enough".
+! There is code in the parser module  m_fsm to avoid buffer overflows
+! caused by pcdata values.
+!
+! This module is re-used from the parser package.
+! Most of the routines are superfluous at this point.
+!
+! In a forthcoming implementation it could be made dynamical...
+!
+integer, parameter, public   :: MAX_BUFF_SIZE  = 2000
+integer, parameter, private  :: BUFF_SIZE_WARNING  = 1750
+!
+type, public  :: buffer_t
+private
+      integer                       :: size
+      character(len=MAX_BUFF_SIZE)  :: str
+end type buffer_t
+
+public :: add_to_buffer
+public :: print_buffer, str, char, len
+public :: operator (.equal.)
+public :: buffer_nearly_full, reset_buffer
+
+
+!----------------------------------------------------------------
+interface add_to_buffer
+      module procedure add_str_to_buffer
+end interface
+private :: add_char_to_buffer, add_str_to_buffer
+
+interface operator (.equal.)
+      module procedure compare_buffers, compare_buffer_str, &
+             compare_str_buffer
+end interface
+private :: compare_buffers, compare_buffer_str, compare_str_buffer
+
+interface str
+      module procedure buffer_to_str
+end interface
+interface char                 ! Experimental
+      module procedure buffer_to_str
+end interface
+private :: buffer_to_str
+
+interface len
+   module procedure buffer_length
+end interface
+private :: buffer_length
+
+CONTAINS
+!==================================================================
+
+!----------------------------------------------------------------
+function compare_buffers(a,b) result(equal)     ! .equal. generic
+type(buffer_t), intent(in)  :: a
+type(buffer_t), intent(in)  :: b
+logical                     :: equal
+
+equal = ((a%size == b%size) .and. (a%str(1:a%size) == b%str(1:b%size)))
+
+end function compare_buffers
+
+!----------------------------------------------------------------
+function compare_buffer_str(buffer,str) result(equal) ! .equal. generic
+type(buffer_t), intent(in)   :: buffer
+character(len=*), intent(in) :: str
+logical                      :: equal
+
+equal = (buffer%str(1:buffer%size) == trim(str))
+
+end function compare_buffer_str
+
+!----------------------------------------------------------------
+function compare_str_buffer(str,buffer) result(equal) ! .equal. generic
+character(len=*), intent(in) :: str
+type(buffer_t), intent(in)   :: buffer
+logical                     :: equal
+
+equal = (buffer%str(1:buffer%size) == trim(str))
+
+end function compare_str_buffer
+
+!----------------------------------------------------------------
+subroutine add_char_to_buffer(c,buffer)
+character(len=1), intent(in)   :: c
+type(buffer_t), intent(inout)  :: buffer
+
+integer   :: n
+buffer%size = buffer%size + 1
+n = buffer%size
+
+if (n> MAX_BUFF_SIZE) then
+  stop "wxml Buffer overflow: long unbroken string of pcdata or attribute value..."
+!  RETURN
+!
+endif
+
+buffer%str(n:n) = c
+end subroutine add_char_to_buffer
+
+!----------------------------------------------------------------
+subroutine add_str_to_buffer(s,buffer)
+character(len=*), intent(in)   :: s
+type(buffer_t), intent(inout)  :: buffer
+
+integer   :: n, len_s, last_pos
+
+len_s = len(s)
+last_pos = buffer%size
+buffer%size = buffer%size + len_s
+n = buffer%size
+
+if (n> MAX_BUFF_SIZE) then
+  stop "wxml Buffer overflow: long unbroken string of pcdata or attribute value..."
+!  RETURN
+endif
+
+buffer%str(last_pos+1:n) = s
+end subroutine add_str_to_buffer
+
+!----------------------------------------------------------------
+subroutine reset_buffer(buffer)
+type(buffer_t), intent(inout)  :: buffer
+
+buffer%size = 0
+
+end subroutine reset_buffer
+
+!----------------------------------------------------------------
+subroutine print_buffer(buffer)
+type(buffer_t), intent(in)  :: buffer
+
+integer :: i
+
+do i = 1, buffer%size
+      write(unit=6,fmt="(a1)",advance="no") buffer%str(i:i)
+enddo
+
+end subroutine print_buffer
+!----------------------------------------------------------------
+! This is better... but could it lead to memory leaks?
+!
+function buffer_to_str(buffer) result(str)
+type(buffer_t), intent(in)          :: buffer
+character(len=buffer%size)          :: str
+
+str = buffer%str(1:buffer%size)
+end function buffer_to_str
+
+!----------------------------------------------------------------
+function buffer_nearly_full(buffer) result(warn)
+type(buffer_t), intent(in)          :: buffer
+logical                             :: warn
+
+warn = buffer%size > BUFF_SIZE_WARNING
+
+end function buffer_nearly_full
+
+!----------------------------------------------------------------
+function buffer_length(buffer) result(length)
+type(buffer_t), intent(in)          :: buffer
+integer                             :: length
+
+length = buffer%size 
+
+end function buffer_length
+
+
+end module m_wxml_buffer
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/wxml/m_wxml_core.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/wxml/m_wxml_core.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/wxml/m_wxml_core.f90	(revision 2528)
@@ -0,0 +1,380 @@
+module m_wxml_core
+
+use m_wxml_buffer
+use m_wxml_elstack
+use m_wxml_dictionary
+
+logical, private, save  :: pcdata_advance_line_default = .false.
+logical, private, save  :: pcdata_advance_space_default = .false.
+
+integer, private, parameter ::  sp = selected_real_kind(6,30)
+integer, private, parameter ::  dp = selected_real_kind(14,100)
+
+private
+
+type, public :: xmlf_t
+   integer            :: lun
+   type(buffer_t)     :: buffer
+   type(elstack_t)    :: stack
+   type(wxml_dictionary_t) :: dict
+   logical            :: start_tag_closed
+   logical            :: root_element_output
+   logical            :: indenting_requested
+end type xmlf_t
+
+public :: xml_OpenFile, xml_NewElement, xml_EndElement, xml_Close
+public :: xml_AddPcdata, xml_AddAttribute, xml_AddXMLDeclaration
+public :: xml_AddComment, xml_AddCdataSection
+
+public :: xml_AddArray
+interface xml_AddArray
+   module procedure  xml_AddArray_integer,  &
+                xml_AddArray_real_dp, xml_AddArray_real_sp
+end interface
+private :: xml_AddArray_integer,  xml_AddArray_real_dp, xml_AddArray_real_sp
+
+private :: get_unit
+private :: add_eol
+private :: write_attributes
+
+
+integer, private, parameter  :: COLUMNS = 80
+
+CONTAINS
+
+!-------------------------------------------------------------------
+subroutine xml_OpenFile(filename, xf, indent)
+character(len=*), intent(in)  :: filename
+type(xmlf_t), intent(inout)   :: xf
+logical, intent(in), optional :: indent
+
+integer :: iostat
+
+call get_unit(xf%lun,iostat)
+if (iostat /= 0) stop "cannot open file"
+open(unit=xf%lun, file=filename, form="formatted", status="replace", &
+     action="write", position="rewind") ! , recl=65536)
+
+call reset_elstack(xf%stack)
+call reset_dict(xf%dict)
+call reset_buffer(xf%buffer)
+
+xf%start_tag_closed = .true.
+xf%root_element_output = .false.
+
+xf%indenting_requested = .false.
+if (present(indent)) then
+   xf%indenting_requested = indent
+endif
+end subroutine xml_OpenFile
+
+!-------------------------------------------------------------------
+subroutine xml_AddXMLDeclaration(xf,encoding)
+type(xmlf_t), intent(inout)   :: xf
+character(len=*), intent(in), optional :: encoding
+
+if (present(encoding)) then
+   call add_to_buffer("<?xml version=""1.0"" encoding=""" &
+                     // trim(encoding) // """ ?>", xf%buffer)
+else
+   call add_to_buffer("<?xml version=""1.0"" ?>", xf%buffer)
+endif
+end subroutine xml_AddXMLDeclaration
+
+!-------------------------------------------------------------------
+subroutine xml_AddComment(xf,comment)
+type(xmlf_t), intent(inout)   :: xf
+character(len=*), intent(in)  :: comment
+
+call close_start_tag(xf,">")
+call add_eol(xf)
+call add_to_buffer("<!--", xf%buffer)
+call add_to_buffer(comment, xf%buffer)
+call add_to_buffer("-->", xf%buffer)
+end subroutine xml_AddComment
+
+!-------------------------------------------------------------------
+subroutine xml_AddCdataSection(xf,cdata)
+type(xmlf_t), intent(inout)   :: xf
+character(len=*), intent(in)  :: cdata
+
+call close_start_tag(xf,">")
+call add_to_buffer("<![CDATA[", xf%buffer)
+call add_to_buffer(cdata, xf%buffer)
+call add_to_buffer("]]>", xf%buffer)
+end subroutine xml_AddCdataSection
+
+!-------------------------------------------------------------------
+subroutine xml_NewElement(xf,name)
+type(xmlf_t), intent(inout)   :: xf
+character(len=*), intent(in)  :: name
+
+if (is_empty(xf%stack)) then
+   if (xf%root_element_output) stop "two root elements"
+   xf%root_element_output = .true.
+endif
+
+call close_start_tag(xf,">")
+call push_elstack(name,xf%stack)
+call add_eol(xf)
+call add_to_buffer("<" // trim(name),xf%buffer)
+xf%start_tag_closed = .false.
+call reset_dict(xf%dict)
+
+end subroutine xml_NewElement
+!-------------------------------------------------------------------
+subroutine xml_AddPcdata(xf,pcdata,space,line_feed)
+type(xmlf_t), intent(inout)   :: xf
+character(len=*), intent(in)  :: pcdata
+logical, intent(in), optional  :: space
+logical, intent(in), optional  :: line_feed
+
+logical :: advance_line , advance_space
+integer :: n, i, jmax
+integer, parameter   :: chunk_size = 128
+
+advance_line = pcdata_advance_line_default 
+if (present(line_feed)) then
+   advance_line = line_feed
+endif
+
+advance_space = pcdata_advance_space_default 
+if (present(space)) then
+   advance_space = space
+endif
+
+if (is_empty(xf%stack)) then
+   stop "pcdata outside element content"
+endif
+
+call close_start_tag(xf,">")
+
+if (advance_line) then
+   call add_eol(xf)
+   advance_space = .false.
+else
+   if (xf%indenting_requested) then
+      if ((len(xf%buffer) + len_trim(pcdata) + 1) > COLUMNS ) then
+         call add_eol(xf)
+         advance_space = .false.
+      endif
+   endif
+endif
+if (advance_space) call add_to_buffer(" ",xf%buffer)
+if (len(xf%buffer) > 0) call dump_buffer(xf,lf=.false.)
+!
+! We bypass the buffer for the bulk of the dump
+!
+n = len(pcdata)
+!print *, "writing pcdata of length: ", n
+i = 1
+do
+   jmax = min(i+chunk_size-1,n)
+!   print *, "writing chunk: ", i, jmax
+   write(unit=xf%lun,fmt="(a)",advance="no") pcdata(i:jmax)
+   if (jmax == n) exit
+   i = jmax + 1
+enddo
+end subroutine xml_AddPcdata
+
+!-------------------------------------------------------------------
+subroutine xml_AddAttribute(xf,name,value)
+type(xmlf_t), intent(inout)   :: xf
+character(len=*), intent(in)  :: name
+character(len=*), intent(in)  :: value
+
+if (is_empty(xf%stack)) then
+   stop "attributes outside element content"
+endif
+
+if (xf%start_tag_closed)  then
+   stop "attributes outside start tag"
+endif
+if (has_key(xf%dict,name)) then
+   stop "duplicate att name"
+endif
+
+call add_key_to_dict(trim(name),xf%dict)
+call add_value_to_dict(trim(value),xf%dict)
+
+end subroutine xml_AddAttribute
+
+!-----------------------------------------------------------
+subroutine xml_EndElement(xf,name)
+type(xmlf_t), intent(inout)   :: xf
+character(len=*), intent(in)  :: name
+
+character(len=100)  :: current
+
+if (is_empty(xf%stack)) then
+   stop "Out of elements to close"
+endif
+
+call get_top_elstack(xf%stack,current)
+if (current /= name) then
+   print *, "current, name: ", trim(current), " ", trim(name)
+   stop
+endif
+if (.not. xf%start_tag_closed)  then                ! Empty element
+   if (len(xf%dict) > 0) call write_attributes(xf)
+   call add_to_buffer(" />",xf%buffer)
+   xf%start_tag_closed = .true.
+else
+   call add_eol(xf)
+   call add_to_buffer("</" // trim(name) // ">", xf%buffer)
+endif
+call pop_elstack(xf%stack,current)
+
+end subroutine xml_EndElement
+
+!----------------------------------------------------------------
+
+subroutine xml_Close(xf)
+type(xmlf_t), intent(in)   :: xf
+
+write(unit=xf%lun,fmt="(a)") char(xf%buffer)
+close(unit=xf%lun)
+
+end subroutine xml_Close
+
+!==================================================================
+!-------------------------------------------------------------------
+subroutine get_unit(lun,iostat)
+
+! Get an available Fortran unit number
+
+integer, intent(out)  :: lun
+integer, intent(out)  :: iostat
+
+integer :: i
+logical :: unit_used
+
+do i = 10, 99
+   lun = i
+   inquire(unit=lun,opened=unit_used)
+   if (.not. unit_used) then
+      iostat = 0
+      return
+   endif
+enddo
+iostat = -1
+lun = -1
+end subroutine get_unit
+
+!----------------------------------------------------------
+subroutine add_eol(xf)
+type(xmlf_t), intent(inout)   :: xf
+
+integer :: indent_level
+character(len=100), parameter  ::  blanks =  ""
+
+indent_level = len(xf%stack) - 1
+write(unit=xf%lun,fmt="(a)") char(xf%buffer)
+call reset_buffer(xf%buffer)
+
+if (xf%indenting_requested) &
+   call add_to_buffer(blanks(1:indent_level),xf%buffer)
+
+end subroutine add_eol
+!------------------------------------------------------------
+subroutine dump_buffer(xf,lf)
+type(xmlf_t), intent(inout)   :: xf
+logical, intent(in), optional :: lf
+
+if (present(lf)) then
+   if (lf) then
+      write(unit=xf%lun,fmt="(a)",advance="yes") char(xf%buffer)
+   else
+      write(unit=xf%lun,fmt="(a)",advance="no") char(xf%buffer)
+   endif
+else
+   write(unit=xf%lun,fmt="(a)",advance="no") char(xf%buffer)
+endif
+call reset_buffer(xf%buffer)
+
+end subroutine dump_buffer
+
+!------------------------------------------------------------
+subroutine close_start_tag(xf,s)
+type(xmlf_t), intent(inout)   :: xf
+character(len=*), intent(in)  :: s
+
+if (.not. xf%start_tag_closed)  then
+   if (len(xf%dict) > 0)  call write_attributes(xf)
+   call add_to_buffer(s, xf%buffer)
+   xf%start_tag_closed = .true.
+endif
+
+end subroutine close_start_tag
+
+!-------------------------------------------------------------
+subroutine write_attributes(xf)
+type(xmlf_t), intent(inout)   :: xf
+
+integer  :: i, status, size
+character(len=100)  :: key, value
+
+do i = 1, len(xf%dict)
+   call get_key(xf%dict,i,key,status)
+   call get_value(xf%dict,key,value,status)
+   key = adjustl(key)
+   value = adjustl(value)
+   size = len_trim(key) + len_trim(value) + 4
+   if ((len(xf%buffer) + size) > COLUMNS) call add_eol(xf)
+   call add_to_buffer(" ", xf%buffer)
+   call add_to_buffer(trim(key), xf%buffer)
+   call add_to_buffer("=", xf%buffer)
+   call add_to_buffer("""",xf%buffer)
+   call add_to_buffer(trim(value), xf%buffer)
+   call add_to_buffer("""", xf%buffer)
+enddo
+
+end subroutine write_attributes
+
+!---------------------------------------------------------------
+    subroutine xml_AddArray_integer(xf,a,format)
+      type(xmlf_t), intent(inout)         :: xf
+      integer, intent(in), dimension(:)   :: a
+      character(len=*), intent(in), optional  :: format
+
+      call close_start_tag(xf,">")
+      if (len(xf%buffer) > 0) call dump_buffer(xf,lf=.true.)
+      if (present(format)) then
+         write(xf%lun,format) a
+      else
+         write(xf%lun,"(6(i12))") a
+      endif
+    end subroutine xml_AddArray_integer
+
+!-------------------------------------------------------------------
+    subroutine xml_AddArray_real_dp(xf,a,format)
+      type(xmlf_t), intent(inout)         :: xf
+      real(kind=dp), intent(in), dimension(:)   :: a
+      character(len=*), intent(in), optional  :: format
+
+      call close_start_tag(xf,">")
+      if (len(xf%buffer) > 0) call dump_buffer(xf,lf=.true.)
+      if (present(format)) then
+         write(xf%lun,format) a
+      else
+         write(xf%lun,"(4(es20.12))") a
+      endif
+    end subroutine xml_AddArray_real_dp
+
+!------------------------------------------------------------------
+    subroutine xml_AddArray_real_sp(xf,a,format)
+      type(xmlf_t), intent(inout)         :: xf
+      real(kind=sp), intent(in), dimension(:)   :: a
+      character(len=*), intent(in), optional  :: format
+
+      call close_start_tag(xf,">")
+      if (len(xf%buffer) > 0) call dump_buffer(xf,lf=.true.)
+      if (present(format)) then
+         write(xf%lun,format) a
+      else
+         write(xf%lun,"(4(es20.12))") a
+      endif
+    end subroutine xml_AddArray_real_sp
+
+end module m_wxml_core
+
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/wxml/m_wxml_dictionary.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/wxml/m_wxml_dictionary.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/wxml/m_wxml_dictionary.f90	(revision 2528)
@@ -0,0 +1,162 @@
+module m_wxml_dictionary
+
+private
+!
+! A very rough implementation for now
+! It uses fixed-length buffers for key/value pairs,
+! and the maximum number of dictionary items is hardwired.
+
+integer, parameter, private    :: MAX_ITEMS = 30
+type, public :: wxml_dictionary_t
+private
+      integer                               :: number_of_items ! = 0
+      character(len=100), dimension(MAX_ITEMS)  :: key
+      character(len=100), dimension(MAX_ITEMS)  :: value
+end type wxml_dictionary_t
+
+!
+! Building procedures
+!
+public  :: add_key_to_dict, add_value_to_dict, reset_dict
+
+!
+! Query and extraction procedures
+!
+public  :: len
+interface len
+   module procedure number_of_entries
+end interface
+public  :: number_of_entries
+public  :: get_key
+public  :: get_value
+public  :: has_key
+public  :: print_dict
+!
+interface get_value
+   module procedure wxml_get_value
+end interface
+
+CONTAINS
+
+!------------------------------------------------------
+function number_of_entries(dict) result(n)
+type(wxml_dictionary_t), intent(in)   :: dict
+integer                          :: n
+
+n = dict%number_of_items
+
+end function number_of_entries
+
+!------------------------------------------------------
+function has_key(dict,key) result(found)
+type(wxml_dictionary_t), intent(in)   :: dict
+character(len=*), intent(in)     :: key
+logical                          :: found
+
+integer  :: n, i
+found = .false.
+n = dict%number_of_items
+do  i = 1, n
+      if (dict%key(i) == key) then
+         found = .true.
+         exit
+      endif
+enddo
+end function has_key
+
+!------------------------------------------------------
+subroutine wxml_get_value(dict,key,value,status)
+type(wxml_dictionary_t), intent(in)            :: dict
+character(len=*), intent(in)              :: key
+character(len=*), intent(out)             :: value
+integer, intent(out)                      :: status
+!
+integer  :: n, i
+
+status = -1
+n = dict%number_of_items
+do  i = 1, n
+      if (dict%key(i) == key) then
+         value = dict%value(i)
+         status = 0
+         RETURN
+      endif
+enddo
+
+end subroutine wxml_get_value
+
+!------------------------------------------------------
+subroutine get_key(dict,i,key,status)
+!
+! Get the i'th key
+!
+type(wxml_dictionary_t), intent(in)            :: dict
+integer, intent(in)                       :: i
+character(len=*), intent(out)             :: key
+integer, intent(out)                      :: status
+
+if (i <= dict%number_of_items) then
+      key = dict%key(i)
+      status = 0
+else
+      key = ""
+      status = -1
+endif
+
+end subroutine get_key
+
+!------------------------------------------------------
+subroutine add_key_to_dict(key,dict)
+character(len=*), intent(in)          :: key
+type(wxml_dictionary_t), intent(inout)   :: dict
+
+integer  :: n
+
+n = dict%number_of_items
+if (n == MAX_ITEMS) then
+      write(unit=0,fmt=*) "Dictionary capacity exceeded !"
+      RETURN
+endif
+
+n = n + 1
+dict%key(n) = key
+dict%number_of_items = n
+
+end subroutine add_key_to_dict
+
+!------------------------------------------------------
+! Assumes we build the dictionary in an orderly fashion,
+! so one adds first the key and then immediately afterwards the value.
+!
+subroutine add_value_to_dict(value,dict)
+character(len=*), intent(in)          :: value
+type(wxml_dictionary_t), intent(inout)   :: dict
+
+integer  :: n
+
+n = dict%number_of_items
+dict%value(n) = value
+
+end subroutine add_value_to_dict
+
+!------------------------------------------------------
+subroutine reset_dict(dict)
+type(wxml_dictionary_t), intent(inout)   :: dict
+
+dict%number_of_items = 0
+
+end subroutine reset_dict
+
+!------------------------------------------------------
+subroutine print_dict(dict)
+type(wxml_dictionary_t), intent(in)   :: dict
+
+integer  :: i
+
+do i = 1, dict%number_of_items
+      print *, trim(dict%key(i)), " = ", trim(dict%value(i))
+enddo
+
+end subroutine print_dict
+
+end module m_wxml_dictionary
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/wxml/m_wxml_elstack.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/wxml/m_wxml_elstack.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/wxml/m_wxml_elstack.f90	(revision 2528)
@@ -0,0 +1,143 @@
+module m_wxml_elstack
+
+private
+
+!
+! Simple stack to keep track of which elements have appeared so far
+!
+integer, parameter, private            :: STACK_SIZE = 20
+
+type, public :: elstack_t
+private
+      integer                                    :: n_items
+      character(len=100), dimension(STACK_SIZE)  :: data
+end type elstack_t
+
+public  :: push_elstack, pop_elstack, reset_elstack, print_elstack
+public  :: get_top_elstack, is_empty, get_elstack_signature
+public  :: len
+
+interface len
+   module procedure number_of_items
+end interface
+private :: number_of_items
+
+interface is_empty
+      module procedure is_empty_elstack
+end interface
+private :: is_empty_elstack
+
+CONTAINS
+
+!-----------------------------------------------------------------
+subroutine reset_elstack(elstack)
+type(elstack_t), intent(inout)  :: elstack
+
+elstack%n_items = 0
+
+end subroutine reset_elstack
+
+!-----------------------------------------------------------------
+function is_empty_elstack(elstack) result(answer)
+type(elstack_t), intent(in)  :: elstack
+logical                    :: answer
+
+answer = (elstack%n_items == 0)
+end function is_empty_elstack
+
+!-----------------------------------------------------------------
+function number_of_items(elstack) result(n)
+type(elstack_t), intent(in)  :: elstack
+integer                      :: n
+
+n = elstack%n_items
+end function number_of_items
+
+!-----------------------------------------------------------------
+subroutine push_elstack(item,elstack)
+character(len=*), intent(in)      :: item
+type(elstack_t), intent(inout)  :: elstack
+
+integer   :: n
+
+n = elstack%n_items
+if (n == STACK_SIZE) then
+      stop "*Element stack full"
+endif
+n = n + 1
+elstack%data(n) = item
+elstack%n_items = n
+
+end subroutine push_elstack
+
+!-----------------------------------------------------------------
+subroutine pop_elstack(elstack,item)
+type(elstack_t), intent(inout)     :: elstack
+character(len=*), intent(out)        :: item
+
+!
+! We assume the elstack is not empty... (the user has called is_empty first)
+!
+integer   :: n
+
+n = elstack%n_items
+if (n == 0) then
+      stop "*********Element stack empty"
+endif
+item = elstack%data(n)
+elstack%n_items = n - 1
+
+end subroutine pop_elstack
+
+!-----------------------------------------------------------------
+subroutine get_top_elstack(elstack,item)
+!
+! Get the top element of the stack, *without popping it*.
+!
+type(elstack_t), intent(in)        :: elstack
+character(len=*), intent(out)        :: item
+
+!
+! We assume the elstack is not empty... (the user has called is_empty first)
+!
+integer   :: n
+
+n = elstack%n_items
+if (n == 0) then
+      stop "*********Element stack empty"
+endif
+item = elstack%data(n)
+
+end subroutine get_top_elstack
+
+!-----------------------------------------------------------------
+subroutine print_elstack(elstack,unit)
+type(elstack_t), intent(in)   :: elstack
+integer, intent(in)           :: unit
+integer   :: i
+
+do i = elstack%n_items, 1, -1
+      write(unit=unit,fmt=*) trim(elstack%data(i))
+enddo
+
+end subroutine print_elstack
+
+!-------------------------------------------------------------
+subroutine get_elstack_signature(elstack,string)
+type(elstack_t), intent(in)   :: elstack
+character(len=*), intent(out) :: string
+integer   :: i, length, j
+
+string = ""
+j = 0
+do i = 1, elstack%n_items
+   length = len_trim(elstack%data(i))
+   string(j+1:j+1) = "/"
+   j = j+1
+   string(j+1:j+length) = trim(elstack%data(i))
+   j = j + length
+enddo
+
+end subroutine get_elstack_signature
+
+end module m_wxml_elstack
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/wxml/m_wxml_text.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/wxml/m_wxml_text.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/wxml/m_wxml_text.f90	(revision 2528)
@@ -0,0 +1,73 @@
+module m_wxml_text
+!
+integer, private, parameter ::  sp = selected_real_kind(6,30)
+integer, private, parameter ::  dp = selected_real_kind(14,100)
+!
+! TODO : Add optional format parameter
+!
+private
+
+public :: str
+
+interface str
+   module procedure  str_integer,  str_real_dp, str_real_sp, &
+                     str_logical
+end interface
+private :: str_integer,  str_real_dp, str_real_sp, str_logical
+
+CONTAINS
+
+      function str_integer(int,format) result(s)
+      integer, intent(in)   :: int
+      character(len=*), intent(in), optional  :: format
+      character(len=100)    :: s
+
+      if (present(format)) then
+         write(s,format) int
+      else
+         write(s,"(i25)") int
+      endif
+      s = adjustl(s)
+      end function str_integer
+
+      function str_logical(log,format) result(s)
+      logical, intent(in)   :: log
+      character(len=*), intent(in), optional  :: format
+      character(len=100)    :: s
+
+      if (present(format)) then
+         write(s,format) log
+      else
+         write(s,"(l1)") log
+      endif
+      s = adjustl(s)
+      end function str_logical
+
+      function str_real_dp(x,format) result(s)
+      real(kind=dp), intent(in)   :: x
+      character(len=*), intent(in), optional  :: format
+      character(len=100)    :: s
+
+      if (present(format)) then
+         write(s,format) x
+      else
+         write(s,"(g22.12)") x
+      endif
+      s = adjustl(s)
+      end function str_real_dp
+
+      function str_real_sp(x,format) result(s)
+      real(kind=sp), intent(in)   :: x
+      character(len=*), intent(in), optional  :: format
+      character(len=100)    :: s
+
+      if (present(format)) then
+         write(s,format) x
+      else
+         write(s,"(g22.12)") x
+      endif
+      s = adjustl(s)
+      end function str_real_sp
+
+
+end module m_wxml_text
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/xpath/Developer.Guide
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/xpath/Developer.Guide	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/xpath/Developer.Guide	(revision 2528)
@@ -0,0 +1,63 @@
+Developer Notes for the XPATH-lite API
+
+This API is built on top of the more fundamental SAX one. The basic
+idea is to have a set of programable handlers that communicate among
+themselves and with the parser via module variables.
+
+A new pseudo-handler, "signal_handler", has been added to the optional
+argument list of xml_parse(). In the current implementation it just
+checks whether a stop signal has been raised by the user side of the
+program (for example, after a "begin tag" event, or after going out
+of the scope of a parent element).
+
+Since the SAX parser is stream-oriented, and XPATH searches can be
+done in any order, there are new routines to rewind the XML file and
+to synchronize the physical file reader with a previously saved point
+in the XML tree. 
+
+These tools, and the rather sophisticated path-matching routine
+provided (which allows for wildcards and the "//" construction) would
+be enough for standard use, as implemented in the routine
+"get_node". However, there is also the possibility of performing
+searches constrained to a given ancestor element ("context" searches)
+so that blocks of logically related information can be processed
+together. A context is implicitly created by a call to
+"mark_node". Contexts can be saved and "synched" to, allowing for
+repeated constrained searches (calls with relative paths). Contexts
+can even be passed to subroutines to package the parsing of common
+elements once and for all. (See for example Examples/xpath/pseudo.f90).
+This feature is nevertheless in need of a more rigorous specification:
+
+* What should be the behavior if a "mark_node" is followed by a
+  call to "get_node" with an absolute path?
+* Should there always be an "automatic rewind" to the beginning of the
+  context before any successive calls to "get_node"?
+
+
+LIMITATIONS
+
+The pcdata buffer provided by the user as a character variable could
+overflow.  Note that the parser itself uses a string of length
+MAX_PCDATA_SIZE (currently 65536) as a buffer to hold PCDATA. A
+warning is issued if there is not enough space (in the user or in the
+system buffer) to hold the data.
+
+Support for converting PCDATA characters to numerical arrays "on the
+fly" is planned for a forthcoming version.
+
+
+The coding style is that of the F subset of Fortran90. I strongly
+believe that it makes for better coding and fewer errors.
+Go to http://www.fortran.com/imagine1/ and get a feel for it. You can
+download free implementations for Linux and Windows, or get an
+inexpensive CD+Book combination to help support the project. Of course,
+F *is* Fortran, so you can always compile it with a Fortran compiler.
+
+
+
+
+
+
+
+
+
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/xpath/flib_xpath.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/xpath/flib_xpath.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/xpath/flib_xpath.f90	(revision 2528)
@@ -0,0 +1,12 @@
+module flib_xpath
+
+!
+! Stub module to gather all the XML functionality needed by the user
+! 
+use flib_sax
+use m_path
+
+public
+
+end module flib_xpath
+
